/*
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 *    BESEnsembleSelection.java
 *    Copyright (C) 1999-2012 University of Waikato, Hamilton, New Zealand
 *
 */
package weka.classifiers.meta.baggingEnsembleSelection;

import java.io.File;

/**
 *
 * @author Quan Sun (quan.sun.nz@gmail.com)
 * @author University of Waikato
 * @author Cornell University
 */
public class BESEnsembleSelection {
    
    public static final int ALGORITHM_FORWARD = 0;
    public static final int ALGORITHM_BACKWARD = 1;
    public static final int ALGORITHM_FORWARD_BACKWARD = 2;
    public static final int ALGORITHM_BEST = 3;
    public static final int ALGORITHM_BUILD_LIBRARY = 4;
    public static final int ALGORITHM_LR = 5;    
    private static final int MAX_DEFAULT_DIRECTORIES = 1000;
    
    public static String getDefaultWorkingDirectory() {

        String defaultDirectory = new String("");

        boolean success = false;

        int i = 1;

        while (i < MAX_DEFAULT_DIRECTORIES && !success) {

            File f = new File(System.getProperty("user.home"), "Ensemble-" + i);

            if (!f.exists() && f.getParentFile().canWrite()) {
                defaultDirectory = f.getPath();
                success = true;
            }
            i++;

        }

        if (!success) {
            defaultDirectory = new String("");
            // should we print an error or something?
        }

        return defaultDirectory;
    }
}
